=== hrplib/CMakeLists.txt ===

include (${CMAKE_MODULE_PATH}/macros.cmake)
SET(HRPSOVERSION 0)

if(ENABLE_INSTALL_RPATH)
  SET(CMAKE_INSTALL_RPATH "$ORIGIN")
endif()

ADD_SUBDIRECTORY(hrpCorba)
ADD_SUBDIRECTORY(hrpUtil)
ADD_SUBDIRECTORY(hrpCollision)
ADD_SUBDIRECTORY(hrpModel)
ADD_SUBDIRECTORY(hrpRTM)

if(NOT QNXNTO)
  ADD_SUBDIRECTORY(hrpPlanner)
endif(NOT QNXNTO)
