=== idl/CMakeLists.txt ===
ADD_SUBDIRECTORY(OpenRTM)
ADD_SUBDIRECTORY(OpenHRP)
