=== idl/OpenRTM/CMakeLists.txt ===
if( OPENRTM_VERSION STREQUAL OPENRTM_VERSION110 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION120)
  ADD_SUBDIRECTORY(1.1.0)
elseif( OPENRTM_VERSION STREQUAL OPENRTM_VERSION100 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION101 OR OPENRTM_VERSION STREQUAL OPENRTM_VERSION102 )
  ADD_SUBDIRECTORY(1.0.0)
elseif( OPENRTM_VERSION STREQUAL OPENRTM_VERSION042 )
  ADD_SUBDIRECTORY(0.4.2)
endif()
